'use strict';

var tComm = require('t-comm');
var loaderUtils = require('loader-utils');

function isInTarget(files, current) {
    return !!files.find((item) => {
        if (tComm.isRegExp(item)) {
            return item.test(current);
        }
        return item.indexOf(current) > -1;
    });
}
function replaceSource(source, replaceList, file) {
    let result = source;
    for (const item of replaceList) {
        const { from, to, files } = item;
        if (!isInTarget(files, file)) {
            continue;
        }
        if (tComm.isRegExp(from)) {
            result = result.replace(from, to);
        }
        else {
            result = result.replaceAll(from, to);
        }
    }
    return result;
}
function replaceContent(source) {
    tComm.replaceAllPolyfill();
    const options = loaderUtils.getOptions(this) || {};
    const { replaceList = [] } = options;
    if (!replaceList) {
        return source;
    }
    const result = replaceSource(source, replaceList, this.resourcePath);
    return result;
}

module.exports = replaceContent;
